exec("MercsIncMultiplayerStdLib.cs");
exec("MIConfigCosts.cs");
exec("MercsIncAIList.cs");
exec("MercsIncUnitList.cs");
$server::TeamDamage = true;


function setDefaultMissionOptions()
{
  $server::TeamPlay = true;
  $server::AllowDeathmatch = false;
  $server::AllowTeamPlay = true;	
	
  $server::AllowTeamRed = true;
  $server::AllowTeamBlue = false;
  $server::AllowTeamYellow = false;
  $server::AllowTeamPurple = false;
}


function onMissionLoad()
{
  for(%i = 0; %i<10000; %i++) if(getObjectName(%i) == "AIVehicle") deleteObject(%i);
  $MIstateOfMission = 0;  // 0 = not started, 1 = in progress, 2 = victory, 3 = loss
  $MIinGamePlayers = 0;
  $MIspawnpoint = 0;
  if($MItransportPercent == "") $MItransportPercent = 1;
  if($MIbountyPercent == "") $MIbountyPercent = 1;
  if($MItotalPay == "") $MItotalPay = 800;

  // Mission parameters 
  // 0 = number of targets
  // 1 = types of targets
  // 2 = AI Pilot strength
  if($MImissionParameter[0] == "") $MImissionParameter[0] = 1;
  if($MImissionParameter[1] == "") $MImissionParameter[1] = 1;
  if($MImissionParameter[2] == "") $MImissionParameter[2] = 1;

  if($MIminDistance == "") $MIminDistance = 1000;
  if($MImaxDistance == "") $MImaxDistance = 1500;

  %count = (playerManager::getPlayerCount());
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %player.MIdied = 0;
    %player.MIstartMission = 0;
    %player.MIabort = 0;     // 0 = no abort order; 1 = unconfirmed; 2 = confirmed; 3 = aborted
  }
}


//======================


function player::onAdd(%player)
{
  %player.MIdied = 0;
  %player.MIloggedIn = 0;
  %player.MIstartMission = 0;
  %player.MIabort = 0;
}


function player::onRemove(%player)
{
  %count = (playerManager::getPlayerCount() - 1);
  if(%count == 0)
  {
    $MIstateOfMission = 3;
    schedule("missionEndConditionMet();", 1);
  }
  if( $MIstateOfMission == 1 ) return;
  else Mercs::startCheck();
}


function vehicle::OnAdd(%vehicle)
{
  %player = playermanager::vehicleIDtoPlayerNum(%vehicle);
  if(%player == 0) return;
  %player.status = 0;

  if($MIspawnpoint == 0)                                       // Move the players' spawn point around randomly
  {
    $MIspawnpoint = 1;
    %x = randomInt(-6000, 6000);
    %y = randomInt(-6000, 6000);
    %z = getTerrainHeight(%x, %y);
    $playerMarker = newObject("playerMarker", Simtrigger);
    $playerMarker.x = %x;
    $playerMarker.y = %y;
    $playerMarker.z = %z;
    setPosition($playerMarker, %x, %y, %z);
    setPosition(%vehicle, %x, %y, %z);
  }
  else
  {
    %distance = 0;
    while(%distance < 50 || %distance > 300)
    {
      %x2 = $playerMarker.x + randomInt(-300, 300);
      %y2 = $playerMarker.y + randomInt(-300, 300);

      %xsqr2 = (%x2 - $playerMarker.x) * (%x2 - $playerMarker.x);
      %ysqr2 = (%y2 - $playerMarker.y) * (%y2 - $playerMarker.y);
      %distance = sqrt( %xsqr2 + %ysqr2);
    }
    %z2 = getTerrainHeight(%x2, %y2);
    setPosition(%vehicle, %x2, %y2, %z2);
  }


  setTeam(%vehicle, *IDSTR_TEAM_RED);

  if(%player.MIdied == 1)
  {
    damageobject(%vehicle, 50000);
    say(%player, 0, "You have already died.  Please wait for the mission to complete (your bonus will be forfeit if you quit early.");
    return;
  }

  if($MIstateOfMission != 0)
  {
    say(%player, 0, "You cannot join a mission in progress.  Please wait until the mission ends.");
    damageobject(%vehicle, 50000);
    return;
  }

  if(%player.MIloggedIn != 1)
  {
    damageobject(%vehicle, 50000);
    messagebox(%player, "Sorry, this mission has already launched.  Please wait until the battlegroup returns to the lobby.  Thank you for your patience.");
  }
  else
  {
    redrop(%vehicle);
    %vehicleCost = MIConfigCosts::checkvalue(%vehicle);
    %player.MIvehicleCost = %vehicleCost;
    if(%vehicleCost > (%player.MImoney + 1) )
    {
      messagebox(%player, "Your vehicle cost is $" @ %vehicleCost @ ".  You only have $" @ %player.MImoney @ " in your account.  Please select a less expensive vehicle.");
      damageobject(%vehicle, 50000);
    }
    else
    {
      %player.MItransportCost = Mercs::round(%vehicleCost * $MItransportPercent / 100);
      messagebox(%player, "Your vehicle cost is $" @ %vehicleCost @ ".  Transport fees will be $" @ %player.MItransportCost @ ".  Please log in again to confirm your selection.");
      Mercs::keepVehicleShutdown(%vehicle);
      %player.MIdied = 0;
    }
  }
}


function vehicle::OnDestroyed(%target, %attacker)
{
  if($MIstateOfMission == 0) return;

  %attackerPlayer = playerManager::vehicleIdToPlayerNum(%attacker);
  %targetPlayer = playerManager::vehicleIdToPlayerNum(%target);

  if(%targetPlayer != 0)
  {
    if(%targetPlayer.MIstartMission != 1)
    {
      return;
    }
    else if(%targetPlayer.MIabort == 3)
    {
      say(0, 0, getName(%targetPlayer) @ " has been extracted off the field.");
      %player.MIdied = 1;
      %targetPlayer.MIstartMission = 0;
      $MIinGamePlayers--;
      %targetPlayer.MItransportCost = 0;
    }
    else
    {
      say(0, 0, getName(%targetPlayer) @ " is down");
      %player.MIdied = 1;
      %targetPlayer.MIstartMission = 0;
      $MIinGamePlayers--;
      say(%targetPlayer, 0, "$" @ %targetPlayer.MIvehicleCost @ " fee for losing your vehicle.  Please remain in the vicinity until mission end to collect your bonus.");
      %fee = %targetPlayer.MIvehicleCost * -1;
      %targetPlayer.MItransportCost = 0;
      Mercs::addMoney(%targetPlayer, %fee);
      %targetPlayer.MIlostVehicle = 1;
    }
  }

  else
  {
    if(%attackerPlayer == 0) return;
    %target.status = 0;
    %points = Mercs::round(MIConfigCosts::checkValue(%target) * $MIbountyPercent / 100);

    if(%target != %attacker)
    {
      %attackerPlayer.MIbounty = %attackerPlayer.MIbounty + %points;
      say(0, 0, getName(%attackerPlayer) @ " neutralized a Cybrid ($" @ %points @ " bounty).");
    }

    $MItargets--;
    if($MItargets < 1)
    {
      $MIstateOfMission = 2;
      say(0, 0, "Mission complete.");
      Mercs::endMission();
    }
  }

  if($MIinGamePlayers < 1)
  {
    $MIstateOfMission = 3;
    say(0, 0, "Mission failed!");
    $MItotalPay = 0;
    Mercs::endMission();
  }
}



//===================


function Mercs::addMoney(%player, %money)
{
  %player.MImoney = %player.MImoney + %money;
  if(%player.MImoney < 0)
  {
    %player.MIdeficit = %player.MImoney;
    %player.MImoney = 0;
  }
  $MIPlayerMoney[%player.MIid] = %player.MImoney;  
  Mercs::InscribePlayers();
}


function Mercs::endMission()
{
  %count = playerManager::getPlayerCount();
  if(%count != 0) Mercs::payouts();

  $MImissionParameter[0] = "";
  $MImissionParameter[1] = "";
  $MImissionParameter[2] = "";
  $MIspawnPoint = 0;

  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %player.MIAbort = 0;
  }

  schedule("missionEndConditionMet();", 10);
}


function Mercs::inscribePlayers()
{
  $MIplaceHolder = "Mercenaries, Inc. Player List";
  export("$MIplaceHolder", "multiplayer\\MercsIncPlayerList.cs", overwrite);
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "");
  fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayers = " @ $MIPlayers @ ";");

  for(%i=0; %i<$MIPlayers; %i++)
  {
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayer[" @ %i @ "] = \"" @ $MIPlayer[%i] @ "\";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerMoney[" @ %i @ "] = " @ $MIPlayerMoney[%i] @ ";");
    fileWrite( "multiplayer\\MercsIncPlayerList.cs" , append, "$MIPlayerPassword[" @ %i @ "] = \"" @ $MIPlayerPassword[%i] @ "\";");
  }
}


function Mercs::keepVehicleShutdown(%vehicle)
{
  if($MIstateOfMission != 0)
  {
    order(%vehicle, shutdown, false);
    return;
  }

  if(!isShutdown(%vehicle)) order(%vehicle, shutdown, true);
  if(playermanager::vehicleIDToPlayerNum(%vehicle) == 0) return;
  schedule("Mercs::keepVehicleShutdown(" @ %vehicle @ ", true);", 1);
}


function Mercs::moveMarker()
{
    %distance = 0;
    %player = playerManager::getPlayerNum(0);
    %vehicle = playerManager::playerNumToVehicleId(%player);
    %x = getPosition(%vehicle, x);
    %y = getPosition(%vehicle, y);

    while(%distance < 1000 || %distance > 1500)
    {
      %x2 = randomInt(%x - 3000, %x + 3000);
      %y2 = randomInt(%y - 3000, %y + 3000);

      %xsqr = (%x - %x2) * (%x - %x2);
      %ysqr = (%y - %y2) * (%y - %y2);

      %distance = sqrt( %xsqr + %ysqr);
    }
    %z2 = getTerrainHeight(%x2, %y2);
    setPosition($marker, %x2, %y2, %z2);    
    $marker.x = %x2;
    $marker.y = %y2;

  	%dx = (%x2 - %x) / %distance;
  	%dy = (%y2 - %y) / %distance;
  	if(%dy >= 0.866) %dir = "north";
  	if(((%dy < 0.866) && (%dy > 0)) && ((%dx < 0.866) && (%dx > 0)))
  		%dir = "northeast";
  	if(%dx >= 0.866) %dir = "east";
  	if(((%dy > -0.866) && (%dy < 0)) && ((%dx < 0.866) && (%dx > 0)))
	  		%dir = "southeast";
  	if(%dy <= -0.866) %dir = "south";
  	if(((%dy > -0.866) && (%dy < 0)) && ((%dx > -0.866) && (%dx < 0)))
  		%dir = "southwest";
  	if(%dx <= -0.866) %dir = "west";
  	if(((%dy < 0.866) && (%dy > 0)) && ((%dx > -0.866) && (%dx < 0)))
  		%dir = "northwest";
  	%distance = floor(%distance+0.5);
  	Say(0,0,"TACCOM: Radar reports an infestation "@ %distance @"m to the "@%dir@".");
}


function Mercs::payouts()
{
  %missionPay = $MItotalPay;
  %count = playerManager::getPlayerCount();

  %mercCount = 0;
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIloggedIn == 1 && %player.MIabort != 3) %mercCount++;
  }
  if(%mercCount != 1) %mercPlural = "s ";
   else %mercPlural = "";

  %missionPayPerPlayer = Mercs::round(%missionPay / %mercCount);

  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %player.MIstartMission = 0;

    if(%player.MIabort == 3)
    {
      echo("On!");
      if($MIstateOfMission == 2) say(%player, 0, "Mission succeeded; no payout for extracted mercs.  $50 deducted for extraction costs.  " @
         "Your new account: $" @ %player.MImoney);
      else say(%player, 0, "Mission failed; merc extracted.  $50 deducted for extraction costs.  " @
         "Your new account: $" @ %player.MImoney);
    }
    else
    {
      %playerPayout = 0;
      %playerPayout = %missionPayPerPlayer;
      %playerPayout = %playerPayout + %player.MIbounty;
      %playerPayout = %playerPayout - %player.MItransportCost;
      %playerPayout = %playerPayout + %player.deficit;
  
      %player.deficit = 0;
  
      if(%playerPayout < 0) %playerPayout = 0;
  
      Mercs::addMoney(%player, %playerPayout);
  
      if($MIstateOfMission == 2) %outCome = "Mission completed\n";
       else if($MIstateOfMission == 3) %outCome = "Mission failed\n\nNo mission pay\n";
      if(%missionPayPerPlayer > 0) %missionNote = "$" @ %missionPay @ " total pay for " @ %mercCount @ " merc" @ %mercPlural @ " = $" @ %missionPayPerPlayer @ " split\n"; 
       else %missionNote = "";
      if(%player.MIbounty > 0) %bountyNote = "+$" @ %player.MIbounty @ " kill bounty\n";
       else %bountyNote = "";
      if(%player.MItransportCost > 0) %transportNote = "-$" @ %player.MItransportCost @ " transport fees\n";
       else %transportNote = "";
      if(%player.MIlostVehicle == 1 && %player.MIvehicleCost > 1 ) %lostVehNote = "-$" @ %player.MIvehicleCost @ " (lost vehicle)\n";
       else %lostVehNote = "";
  
      messagebox(%player, %outCome @ %missionNote @ %bountyNote @ %transportNote @ %lostVehNote @ "Total payout: $" @ %playerPayout @ 
           "\n Your new account: $" @ %player.MImoney);
    }
  }
}


function Mercs::spawnBattleGroup(%vehiclesLeft)
{
  $MIBattleGroups++;
  newObject( "BattleGroup" @ $MIBattleGroup, SimGroup );
  addToSet( "MissionCleanup", "BattleGroup" @ $MIBattleGroup );

  %vehiclesInBattleGroup = RandomInt(1, 6);
  if(%vehiclesInBattleGroup > %vehiclesLeft) %vehiclesInBattleGroup = %vehiclesLeft;

  for(%i=0; %i<%vehiclesInBattleGroup; %i++)
  {
    %herc = MercsIncUnitList::Generator($MIMissionParameter[1]);
    %herc.status = 1;
    addToSet( "MissionCleanup\\BattleGroup" @ $MIBattleGroup, %herc );
    setTeam( %herc, *IDSTR_TEAM_PURPLE );
    setPilotId(%herc, MercsAIList::GetPilot($MImissionParameter[2]) );
    %vehiclesLeft--;

    %distance2 = 0;
    %x3 = $marker.x;
    %y3 = $marker.y;

    while(%distance2 < 50 || %distance2 > 150)
    {
      %x4 = randomInt(%x3 - 200, %x3 + 200);
      %y4 = randomInt(%y3 - 200, %y3 + 200);

      %xsqr2 = (%x3 - %x4) * (%x3 - %x4);
      %ysqr2 = (%y3 - %y4) * (%y3 - %y4);

      %distance2 = sqrt( %xsqr2 + %ysqr2);
    }
    %z4 = getTerrainHeight(%x4, %y4);
    setPosition(%herc, %x4, %y4, %z4);    
		addToSet( "MissionCleanup", %herc );
    order( %herc, holdfire, true );
    schedule( " order( " @ %herc @ ", holdfire, false);", 4 );
    if(%i==0) order(%herc, makeLeader, true);

    %vehCount++;
  }

  %currentGroup = getObjectID("MissionCleanup\\BattleGroup" @ $MIBattleGroup);
	order(%currentGroup, formation, delta);

  if(%vehiclesLeft > 0)
  {
     Mercs::moveMarker();
     %vehiclesLeft = Mercs::spawnBattleGroup(%vehiclesLeft);
  }
  else return %vehiclesLeft;
}


function Mercs::startCheck()
{
  if($MIstateOfMission != 0) return;
  %ready = 1;
  %waitingFor = 0;

  %count = playerManager::getPlayerCount();

  if(%count == 0)
  {
    Mercs::endMission();
  }

  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    if(%player.MIstartMission != 1 && %player.MILoggedIn == 1)
    {
      %ready = 0;
      %waitingFor++;
    }
  }

  if(%ready == 0)
  {
    if(%waitingFor != 1) %plural = "s.";
     else %plural = ".";

    say(0, 0, "Waiting for " @ %waitingFor @ " player" @ %plural );
  }

  else
  {
    say(0, 0, "All pilots have logged in.  Initiating mission.");
    Mercs::startMission();
  }
}


function Mercs::startMission()
{
  $MIstateOfMission = 1;
  $MIBattleGroups = 0;

  %count = playerManager::getPlayerCount();
  for(%i = 0; %i < %count; %i++)
  {
    %player = playerManager::getPlayerNum(%i);
    %vehicle = playerManager::playerNumToVehicleID(%player);
  }

  $MItargets = Mercs::vehiclesInMission($MIMIssionParameter[0]);

  %vehiclesToAllocate = $MItargets;
  %vehCount = 0;

  $marker = newObject("Marker", Simtrigger);
  while(%vehiclesToAllocate > 0)
  {
    Mercs::moveMarker($marker);
    %vehiclesToAllocate = Mercs::spawnBattleGroup(%vehiclesToAllocate);
  }

  deleteObject($marker);
  deleteObject($playerMarker);
}


function Mercs::vehiclesInMission(%difficulty)
{
  if(%difficulty == 1) return(randomInt(1, 2));
  if(%difficulty == 2) return(randomInt(3, 4));
  if(%difficulty == 3) return(randomInt(5, 6));
  if(%difficulty == 4) return(randomInt(7, 8));
  if(%difficulty == 5) return(randomInt(9, 10));
  if(%difficulty == 6) return(randomInt(11, 12));
  if(%difficulty == 7) return(randomInt(13, 14));
  if(%difficulty == 8) return(randomInt(15, 16));
  if(%difficulty == 9) return(randomInt(17, 18));
  if(%difficulty == 10) return(randomInt(19, 20));
}

//===================


function remoteMercs::Login(%player, %password)
{
  if($MIstateOfMission != 0) return;
  if(%player.MIstartMission == 1) return;

  if(%player.MIloggedIn != 1)
  {
    messagebox(%player, "Sorry, this mission has already launched.  Please wait until the battlegroup returns to the lobby.  Thank you for your patience.");
  }
  else
  {
    $MIInGamePlayers++;
    %player.MIstartMission = 1;
    %player.MIbounty = 0;
    %player.MIlostVehicle = 0;
    say(0, 0, getName(%player) @ " has logged in.");
    Mercs::startCheck();
  }
}


function remoteMercs::statusReport(%player)
{
  %testObject = getNextObject("MissionCleanup", %player.status);
  %counter = 0;

  while( ( (getObjectName(%testObject) != "AIVehicle") || %testObject.status != 1) && %counter < 40)
  {
    %testObject = getNextObject("MissionCleanup", %testObject);
    %counter++;
  }

  if(getObjectName(%testObject) == "AIVehicle")
  {
    %vehicleID = playerManager::playerNumToVehicleID(%player);
    %x = getPosition(%vehicleID, x);
    %y = getPosition(%vehicleID, y);

    %target = getObjectID(%testObject);
    %x2 = getPosition(%target, x);
    %y2 = getPosition(%target, y);

    %distance = getDistance(%vehicleID, %target);

  	%dx = (%x2 - %x) / %distance;
  	%dy = (%y2 - %y) / %distance;
  	if(%dy >= 0.866) %dir = "north";
  	if(((%dy < 0.866) && (%dy > 0)) && ((%dx < 0.866) && (%dx > 0)))
  		%dir = "northeast";
  	if(%dx >= 0.866) %dir = "east";
  	if(((%dy > -0.866) && (%dy < 0)) && ((%dx < 0.866) && (%dx > 0)))
  		%dir = "southeast";
  	if(%dy <= -0.866) %dir = "south";
  	if(((%dy > -0.866) && (%dy < 0)) && ((%dx > -0.866) && (%dx < 0)))
  		%dir = "southwest";
  	if(%dx <= -0.866) %dir = "west";
  	if(((%dy < 0.866) && (%dy > 0)) && ((%dx > -0.866) && (%dx < 0)))
  		%dir = "northwest";
  	%distance = floor(%distance+0.5);

    %player.status = %testObject;
    Say(%player,0,"TACCOM: Target detected "@ %distance @"m "@%dir@" from your position.");
  }
  else say(%player, 0, "TACCOM: No targets detected in your vicinity.  Please contact TAC-Support if you feel this is in error.");
}


function remoteMercs::abortMission(%player)
{
  if($MIstateOfMission != 1) return;
  if(%player.MIabort == 0)
  {
    %player.MIabort = 1;
    say(%player, 0, "Confirm abort? All money earned will be forfeit, and a $50 fee will be incurred.");
    return;
  }
  else if(%player.MIabort == 1)
  {
    %player.MIabort = 2;
    say(0, 0, "Extraction teleport in 10 seconds.");
    schedule("abortPlayer(" @ %player @ ");", 10);
  }
}

function abortPlayer(%player)
{
  if(%player.MIdied == 1) return;
  %player.MIabort = 3;
  Mercs::addMoney(%player, -50);
  %vehicle = playerManager::playernumToVehicleID(%player);
  damageObject(%vehicle, 50000);
}

//=====================


function Mercs::round(%number)
{
  %roundNum = %number;
  if(%number > 0)
  {
    %excess = (%number - floor(%number));
    if(%excess >= 0.5)
    {
      %roundNum = (floor(%number) + 1);
    }
    else
    {
      %roundNum = floor(%number);
    }
  }
  if(%number < 0)
  {
    %excess = (floor(%number) - %number);
    if(%excess <= 0.5)
    {
      %roundNum = floor(%number);
    }
    else
    {
      %roundNum = (floor(%number) - 1);
    }
   }
   return %roundNum;
}


function Mercs::statRoll(%number, %sides)
{
  %total = 0;
  for(%i=0; %i<%number; %i++)
  {
    %die = randomInt(1, %sides);
    %total = %total + %die;
  }
  %average = %total / %number;
  %final = %average / ((%sides+1)/2);
  return(%final);
}
